#!/bin/sh

cat <<EOF

--------------------------------------------------
Check HLShield forum for more informations
http://hobby.sarichioi.com/
--------------------------------------------------
EOF



if [ ! -f "hlds_run" ]; then
    echo
    echo "ERROR!!! You must be in the same folder where hlds_run is."
    exit
fi


echo -n "Checking version... "
wget -q http://hobby.sarichioi.com/cstrike/hlshield-version.txt \
    -O /tmp/hlshield-version.txt || \
( echo "failed" ; exit 1 )

avail_ver=$( head -n 1 /tmp/hlshield-version.txt )

inst_ver="none"

if [ -f hlshield-version.txt ]; then
    inst_ver=$( head -n 1 hlshield-version.txt )
fi

echo
echo "  >> available: ${avail_ver}"
echo "  >> installed: ${inst_ver}"

if [ "${avail_ver}" = "${inst_ver}" ]; then
    echo "Your HLShield is already updated."
    exit 0
fi

echo -n "Fetching latest HLShield... "
if ! wget -q http://hobby.sarichioi.com/cstrike/hlshield-${avail_ver}.tar.gz; then
    echo "failed"
    exit 1
fi
echo "done"

echo -n "Unpacking... "
if ! tar zxf hlshield-${avail_ver}.tar.gz; then
    echo "failed"
    exit 1
fi

need_patching=
grep hlshield.so hlds_run >/dev/null || need_patching=1
if [ "$need_patching" = "1" ]; then
    patch=`which patch 2>/dev/null`
    if [ -z ${patch} ]; then
        echo
        echo "Sorry, a can't found the 'patch' utility program in your system".
        echo "You can manually modify the hlds_run file, inserting following"
        echo "line (before 'export LD_LIBRARY_PATH'):"
        echo
        echo "export LD_PRELOAD=./hlshield.so"
        echo
    else
	${patch} -s -t -N < hlds_run.patch >/dev/null
    fi
fi

echo "done"

echo -n "Cleaning up... "
rm -f hlshield-${avail_ver}.tar.gz hlds_run.patch hlds_run.rej hlshield-version.txt
mv /tmp/hlshield-version.txt .
echo "done"
